import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Calculation of perpendiculars with some
// random hyperbolic lines

hyperbolic_line L;

hyperbolic_point A = hyperbolic_point(1,0);
hyperbolic_point B = hyperbolic_point(1,180);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(1,90);
hyperbolic_point B = hyperbolic_point(1,270);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(1,30);
hyperbolic_point B = hyperbolic_point(1,120);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(1,60);
hyperbolic_point B = hyperbolic_point(1,150);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(1,135);
hyperbolic_point B = hyperbolic_point(1,315);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(1.5,0);
hyperbolic_point B = hyperbolic_point(1.5,270);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(1,115);
hyperbolic_point B = hyperbolic_point(1,295);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(0.75,170);
hyperbolic_point B = hyperbolic_point(0.5,210);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(2,70);
hyperbolic_point B = hyperbolic_point(2,230);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(2,190);
hyperbolic_point B = hyperbolic_point(2,340);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(0.6,40);
hyperbolic_point B = hyperbolic_point(0.6,320);
dot(A);
dot(B);
L = hyperbolic_line(A,B);
draw(L, blue);
hyperbolic_line N = hyperbolic_normal(L, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(L, B);
draw(N, red);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
